/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_bootstrap/bootstrap/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKubeadmConfigTemplates implements KubeadmConfigTemplateInterface
type FakeKubeadmConfigTemplates struct {
	Fake *FakeBootstrapV1beta1
	ns   string
}

var kubeadmconfigtemplatesResource = schema.GroupVersionResource{Group: "bootstrap.cluster.x-k8s.io", Version: "v1beta1", Resource: "kubeadmconfigtemplates"}

var kubeadmconfigtemplatesKind = schema.GroupVersionKind{Group: "bootstrap.cluster.x-k8s.io", Version: "v1beta1", Kind: "KubeadmConfigTemplate"}

// Get takes name of the kubeadmConfigTemplate, and returns the corresponding kubeadmConfigTemplate object, and an error if there is any.
func (c *FakeKubeadmConfigTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.KubeadmConfigTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kubeadmconfigtemplatesResource, c.ns, name), &v1beta1.KubeadmConfigTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmConfigTemplate), err
}

// List takes label and field selectors, and returns the list of KubeadmConfigTemplates that match those selectors.
func (c *FakeKubeadmConfigTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.KubeadmConfigTemplateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kubeadmconfigtemplatesResource, kubeadmconfigtemplatesKind, c.ns, opts), &v1beta1.KubeadmConfigTemplateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.KubeadmConfigTemplateList{ListMeta: obj.(*v1beta1.KubeadmConfigTemplateList).ListMeta}
	for _, item := range obj.(*v1beta1.KubeadmConfigTemplateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kubeadmConfigTemplates.
func (c *FakeKubeadmConfigTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kubeadmconfigtemplatesResource, c.ns, opts))

}

// Create takes the representation of a kubeadmConfigTemplate and creates it.  Returns the server's representation of the kubeadmConfigTemplate, and an error, if there is any.
func (c *FakeKubeadmConfigTemplates) Create(ctx context.Context, kubeadmConfigTemplate *v1beta1.KubeadmConfigTemplate, opts v1.CreateOptions) (result *v1beta1.KubeadmConfigTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kubeadmconfigtemplatesResource, c.ns, kubeadmConfigTemplate), &v1beta1.KubeadmConfigTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmConfigTemplate), err
}

// Update takes the representation of a kubeadmConfigTemplate and updates it. Returns the server's representation of the kubeadmConfigTemplate, and an error, if there is any.
func (c *FakeKubeadmConfigTemplates) Update(ctx context.Context, kubeadmConfigTemplate *v1beta1.KubeadmConfigTemplate, opts v1.UpdateOptions) (result *v1beta1.KubeadmConfigTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kubeadmconfigtemplatesResource, c.ns, kubeadmConfigTemplate), &v1beta1.KubeadmConfigTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmConfigTemplate), err
}

// Delete takes name of the kubeadmConfigTemplate and deletes it. Returns an error if one occurs.
func (c *FakeKubeadmConfigTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(kubeadmconfigtemplatesResource, c.ns, name, opts), &v1beta1.KubeadmConfigTemplate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKubeadmConfigTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kubeadmconfigtemplatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.KubeadmConfigTemplateList{})
	return err
}

// Patch applies the patch and returns the patched kubeadmConfigTemplate.
func (c *FakeKubeadmConfigTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.KubeadmConfigTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kubeadmconfigtemplatesResource, c.ns, name, pt, data, subresources...), &v1beta1.KubeadmConfigTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmConfigTemplate), err
}
